function [score]=calcQS(lf,yobs,llim,ulim)

%computes the quadratic score
%inputs: 1) lf=log predictive density function;
%2) yobs = observed y; 3)llim=lower limit; 4) ulim=upper limit
%3) and 4) are for numerical integration

ff=@(x) (exp(lf(x))).^2; %squared of predictive density function
penalty=integral(ff,llim,ulim);
score=2*exp(lf(yobs))-penalty;

end