function [ y, x ] = gen_SVaStab( T, omgv,rho, sigv, alpha )
    %   Generates data from SV with alpha stable returns
    %   See definition in Section 4.4
    pd=makedist('Stable','alpha',alpha,'beta',1,'gam',1,'delta',0);
    vt=random(pd,T,1);
    et=normrnd(0,1,T,1);
    x0=omgv/(1-rho);
    x=zeros(T,1);
    for i=1:T
        if(i==1)
            x(i)=omgv+rho*x0+sigv*vt(i);
        else
            x(i)=omgv+rho*x(i-1)+sigv*vt(i);
        end
    end
    y=exp(x/2).*et;
end

