function [lse]=logSumExpM(M, dim)
%takes the log(sum(exp(l))), of vector l avoiding the exp() of extreme numbers
%by taking log(sum(exp(l-lstar)))+lstar, where lstar is an extreme (min or
%max) of the vector l.
lstar=max(M,[],dim);
[r,c]=size(M);

if(dim==1)
    Ms=repmat(lstar,r,1);
else
    Ms=repmat(lstar,1,c);
end

Mdev=M-Ms;
lse=lstar+log(sum(exp(Mdev),dim));
end
