function [curr_h]=draw_SV_h(y,curr_d,curr_k,curr_sigv,prev_h)

ys=log(y.^2);
sig2=curr_sigv^2;
T=length(y);
hbar=curr_d/(1-curr_k);
%% normal mixture
pi = [0.0073 .10556 .00002 .04395 .34001 .24566 .2575];
mi = [-10.12999 -3.97281 -8.56686 2.77786 .61942 1.79518 -1.08819] - 1.2704;  %% means already adjusted!! %%
sigi = [5.79596 2.61369 5.17950 .16735 .64009 .34023 1.26261];
sqrtsigi = sqrt(sigi);

%% sample S from a 7-point distrete distribution
temprand = rand(T,1);
q = repmat(pi,T,1).*normpdf(repmat(ys,1,7),repmat(prev_h,1,7)+repmat(mi,T,1), repmat(sqrtsigi,T,1));
q = q./repmat(sum(q,2),1,7);
S = 7 - sum(repmat(temprand,1,7)<cumsum(q,2),2)+1;

%% sample h using the precision-based algorithm
% z* = h + d + epsilon*, epsilon* ~ N(0,Sig_y*),
% Hrho h = alpha-tilde + zeta, zeta ~ N(0,Sig_h),
% where 
% d_t = E(epsilon*_t), Sig_y* = diag(var(epsilon*_1), ..., epsilon*_T),
% Sig_h = diag(sig2/(1-phi^2), sig2, ..., sig2)
Hrho = speye(T)-sparse(2:T,1:(T-1),curr_k*ones(1,T-1),T,T);
invSigh = sparse(1:T,1:T,[(1-curr_k^2)/sig2; 1/sig2*ones(T-1,1)]);
d = mi(S)'; invSigystar = spdiags(1./sigi(S)',0,T,T);
alpha = Hrho\[hbar; ((1-curr_k)*hbar)*ones(T-1,1)];
Kh = Hrho'*invSigh*Hrho + invSigystar;
Ch = chol(Kh,'lower');
hhat = Kh\(Hrho'*invSigh*Hrho*alpha + invSigystar*(ys-d));
curr_h = hhat + Ch'\randn(T,1);
end