function [chi_dens]= chi_den_sum_matlab(xval,u,qval, cval)
%compute the density of noncentral Chi2 
Q=length(u);
if (qval <= 0)
	 chi_dens = zeros(Q,Q);
else
	delta = 2*u;         % (Qx1) column vector

	df = 2*qval+2;

    nu = 2*cval*xval;
    
    chi_dens=ncx2pdf(repmat(nu,Q,1),df*ones(Q,Q),repmat(delta,1,Q));
    
    chi_dens=2*cval*chi_dens;
end